﻿
init python:

    class dance_arrow(renpy.Displayable):
        def __init__(self, image, direction, parent):
            super(renpy.Displayable,self).__init__()
            self.image = image
            self.direction = direction
            self.parent = parent

            self.color = "beige"
            self.moving = True
            self.x = 0
            self.y = 0
            self.hit = False
        
        def render(self,width,height,st,at):
            if self.moving:
                self.y += 4
                if self.y > 850:
                    self.color = "red"
                    if self.y > 950:
                        self.moving = False
                        self.parent.miss(self)
            img = "{} {} {}".format(self.image, self.direction, self.color)
            t = Transform(img)
            child_render = renpy.render(t, width, height, st, at)
            cw, ch = child_render.get_size()

            rv = renpy.Render(cw, ch)
            rv.blit(child_render, (self.x, self.y))

            renpy.redraw(self, 0)
            return rv

    class dance_class:
        def __init__(self, music, recipe):
            self.music = music
            self.recipe = recipe
            self.moves = []
            self.misses = 0
        def start(self):
            pass
        def clean(self):
            moves = [i for i in self.moves if i.moving]
            self.moves = moves
        def move(self, move):
            for i in self.moves:
                if i.moving:
                    if i.direction == move:
                        if distance(i.y, 800) < 30:
                            i.color = "green"
                            i.moving = False
                            break

        def spawn(self):
            self.clean()
            direction = random.choice([["w", 200], ["s", 300], ["d",400], ["a",100]])
            move = dance_arrow("dance_arrow", direction[0], self)
            move.x = direction[1]
            self.moves.append(move)
        def miss(self, arrow):
            self.misses += 1
            self.clean()

screen dance_screen():
    default g = dance_class(None,None)

    for i in g.moves:
        add i

    for n,i in enumerate([["a", "K_LEFT"], ["w", "K_UP"], ["s", "K_DOWN"], ["d", "K_RIGHT"]]):
        button:
            padding 0,0 background None xpos (1+n)*100 ypos 800
            add "dance_circle"
            action Function(g.move, i[0]) keysym i

    timer 1 repeat True action Function(g.spawn)

    text str(len(g.moves))


init:
    image dance_arrow w beige:
        Crop((0,0,32,32), "dance/sprites.png")
        zoom 3 nearest True
    image dance_arrow s beige:
        Crop((32,0,32,32), "dance/sprites.png")
        zoom 3 nearest True
    image dance_arrow d beige:
        Crop((64,0,32,32), "dance/sprites.png")
        zoom 3 nearest True
    image dance_arrow a beige:
        Crop((96,0,32,32), "dance/sprites.png")
        zoom 3 nearest True

    image dance_arrow w green:
        Crop((0,32,32,32), "dance/sprites.png")
        zoom 3 nearest True
    image dance_arrow s green:
        Crop((32,32,32,32), "dance/sprites.png")
        zoom 3 nearest True
    image dance_arrow d green:
        Crop((64,32,32,32), "dance/sprites.png")
        zoom 3 nearest True
    image dance_arrow a green:
        Crop((96,32,32,32), "dance/sprites.png")
        zoom 3 nearest True

    image dance_arrow w red:
        Crop((0,64,32,32), "dance/sprites.png")
        zoom 3 nearest True
    image dance_arrow s red:
        Crop((32,64,32,32), "dance/sprites.png")
        zoom 3 nearest True
    image dance_arrow d red:
        Crop((64,64,32,32), "dance/sprites.png")
        zoom 3 nearest True
    image dance_arrow a red:
        Crop((96,64,32,32), "dance/sprites.png")
        zoom 3 nearest True

    image dance_circle:
        Crop((0,96,32,32), "dance/sprites.png")
        zoom 3 nearest True

label dance_example:
    call screen dance_screen

